namespace Twitch {

shared class Message {
	Twitch::MessageType m_messageType;
	string m_channel;
	string m_username;
	string m_text;
	dictionary m_tags;
	uint64 m_timestamp = Time::Stamp * 1000;
}

shared enum MessageType {
	ChatMessage = 1,
	UserNotice = 2,
	UserState = 4,
	Whisper = 8,
	ClearChat = 16,
	ClearMessage = 32,
	HostTarget = 64,
	Notice = 128,
	Join = 256,
	RoomState = 512,
	GlobalUserState = 1024
}

shared enum MessageCode {
	Success,
	NoConnection,
	RateLimited
}

shared class ChannelState {
	string m_name;
	Twitch::Message@ m_userstate;
	Twitch::Message@ m_roomstate;
	bool m_exists = false;
	bool m_checked = false;

	ChannelState(string name) {
		m_name = name;
	}
}

} // end of namespace "Twitch"